; 
    include \masm32\include\masm32rt.inc
    .686
    include timers.asm

    cmpmem_incdec PROTO :DWORD,:DWORD,:DWORD

; 
    .data
      pMem dd 0
      fLen dd 0
    .code
; 
start:
; 
    invoke read_disk_file, chr$("\masm32\m32lib\cmpmem.asm"),
                          ADDR pMem, ADDR fLen
    print ustr$(fLen)," bytes",13,10

    invoke cmpmem, pMem, pMem, fLen
    print ustr$(eax),13,10
    invoke cmpmem_incdec, pMem, pMem, fLen
    print ustr$(eax),13,10

    LOOP_COUNT equ 1000000

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke cmpmem, pMem, pMem, fLen
    counter_end
    print ustr$(eax)," cycles, cmpmem",13,10

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke cmpmem_incdec, pMem, pMem, fLen
    counter_end
    print ustr$(eax)," cycles, cmpmem_incdec",13,10

    free pMem
    inkey "Press any key to exit..."
    exit
; 

align 4

cmpmem_incdec proc buf1:DWORD,buf2:DWORD,bcnt:DWORD

    push esi
    push edi

    mov edx, bcnt
    shr edx, 2                      ; div by 4

    mov esi, buf1
    mov edi, buf2
    xor ecx, ecx

  align 4
  @@:
    mov eax, [esi+ecx]              ; DWORD compare main file
    cmp eax, [edi+ecx]
    jne fail
    add ecx, 4
    ;sub edx, 1
    DEC EDX
    jnz @B

    mov edx, bcnt                   ; calculate any remainder
    and edx, 3
    jz match                        ; exit if its zero
    xor eax, eax                    ; clear EAX for partial writes

  @@:
    mov al, [esi+ecx]               ; BYTE compare tail
    cmp al, [edi+ecx]
    jne fail
    ;add ecx, 1
    INC ECX
    ;sub edx, 1
    DEC EDX
    jnz @B

    jmp match

  fail:
    xor eax, eax                    ; return zero if DIFFERENT
    jmp quit

  match:
    mov eax, 1                      ; return NON zero if SAME

  quit:
    pop edi
    pop esi

    ret

cmpmem_incdec endp

; 

; 

end start
 